"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/es6.object.assign");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.keys");

require("core-js/modules/es6.object.set-prototype-of");

require("core-js/modules/es6.function.name");

var _react = _interopRequireDefault(require("react"));

var _ControlBorder = _interopRequireDefault(require("./ControlBorder"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Control =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Control, _React$Component);

  function Control(props, context) {
    var _this;

    _classCallCheck(this, Control);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Control).call(this, props, context));
    _this.state = {
      id: '',
      type: '',
      properties: []
    };
    return _this;
  }

  _createClass(Control, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.state.id = this.props.id;
    }
  }, {
    key: "setProperties",
    value: function setProperties(properties) {
      this.setState({
        properties: properties
      });
    }
  }, {
    key: "getControlStyle",
    value: function getControlStyle() {}
  }, {
    key: "renderControl",
    value: function renderControl() {}
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          id = _this$props.id,
          name = _this$props.name,
          isVisible = _this$props.isVisible,
          style = _this$props.style,
          labelCol = _this$props.labelCol,
          selectControl = _this$props.selectControl,
          selected = _this$props.selected,
          isRequired = _this$props.isRequired,
          independent = _this$props.independent,
          designmode = _this$props.designmode,
          hasBorder = _this$props.hasBorder,
          hasLabel = _this$props.hasLabel,
          operationType = _this$props.operationType,
          onDragStart = _this$props.onDragStart,
          controlChange = _this$props.controlChange;
      var layout = {
        labelCol: {
          span: parseInt(labelCol, 10)
        },
        wrapperCol: {
          span: 24 - labelCol
        }
      };

      var controlStyle = _objectSpread({
        userSelect: designmode ? 'none' : 'auto'
      }, this.getControlStyle(), style);

      var control = this.renderControl(); // if (hasLabel == null || hasLabel == true) {
      //   control = (
      //     <Form.Item {...layout} name={name} label={name} required={isRequired === '1'} style={{ margin: 0 }}>
      //       {control}
      //     </Form.Item>
      //   );
      // }

      var children = control;

      if (designmode == 'true' && independent == 'true' && hasBorder) {
        children = _react.default.createElement(_ControlBorder.default, {
          id: id,
          type: this.state.type,
          selected: selected,
          style: controlStyle
        }, control);
      }

      var options = {};

      if (onDragStart != null) {
        options.draggable = true;
        options.onDragStart = onDragStart;
      }

      if (controlChange) {
        options.onDrop = function (e) {
          e.preventDefault();
          e.stopPropagation();
          var controlId = e.dataTransfer.getData('controlId');
          controlChange(controlId, id);
        };
      }

      if (this.state.type == 'container') {
        options.className = 'am-list-body';
      }

      if (isVisible === false) {
        return '';
      }

      return _react.default.createElement("div", _extends({
        id: id,
        style: controlStyle,
        onClick: selectControl
      }, options), children);
    }
  }]);

  return Control;
}(_react.default.Component);

exports.default = Control;