"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.keys");

require("core-js/modules/es6.object.set-prototype-of");

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _throttle = _interopRequireDefault(require("./utils/throttle"));

var _threshold = require("./utils/threshold");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

var InfiniteScroll =
/*#__PURE__*/
function (_Component) {
  _inherits(InfiniteScroll, _Component);

  function InfiniteScroll(props) {
    var _this;

    _classCallCheck(this, InfiniteScroll);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(InfiniteScroll).call(this, props));
    _this.lastScrollTop = 0;
    _this.actionTriggered = false;
    _this.state = {
      showLoader: false,
      pullToRefreshThresholdBreached: false
    }; // variables to keep track of pull down behaviour

    _this.startY = 0;
    _this.currentY = 0;
    _this.dragging = false; // will be populated in componentDidMount
    // based on the height of the pull down element

    _this.maxPullDownDistance = 0;
    _this.onScrollListener = _this.onScrollListener.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.throttledOnScrollListener = (0, _throttle.default)(_this.onScrollListener, 150).bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.onStart = _this.onStart.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.onMove = _this.onMove.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.onEnd = _this.onEnd.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.getScrollableTarget = _this.getScrollableTarget.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    return _this;
  }

  _createClass(InfiniteScroll, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this._scrollableNode = this.getScrollableTarget();
      this.el = this.props.height ? this._infScroll : this._scrollableNode || window;
      this.el.addEventListener("scroll", this.throttledOnScrollListener);

      if (typeof this.props.initialScrollY === "number" && this.el.scrollHeight > this.props.initialScrollY) {
        this.el.scrollTo(0, this.props.initialScrollY);
      }

      if (this.props.pullDownToRefresh) {
        this.el.addEventListener("touchstart", this.onStart);
        this.el.addEventListener("touchmove", this.onMove);
        this.el.addEventListener("touchend", this.onEnd);
        this.el.addEventListener("mousedown", this.onStart);
        this.el.addEventListener("mousemove", this.onMove);
        this.el.addEventListener("mouseup", this.onEnd); // get BCR of pullDown element to position it above

        this.maxPullDownDistance = this._pullDown.firstChild.getBoundingClientRect().height;
        this.forceUpdate();

        if (typeof this.props.refreshFunction !== "function") {
          throw new Error("Mandatory prop \"refreshFunction\" missing.\n          Pull Down To Refresh functionality will not work\n          as expected. Check README.md for usage'");
        }
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.el.removeEventListener("scroll", this.throttledOnScrollListener);

      if (this.props.pullDownToRefresh) {
        this.el.removeEventListener("touchstart", this.onStart);
        this.el.removeEventListener("touchmove", this.onMove);
        this.el.removeEventListener("touchend", this.onEnd);
        this.el.removeEventListener("mousedown", this.onStart);
        this.el.removeEventListener("mousemove", this.onMove);
        this.el.removeEventListener("mouseup", this.onEnd);
      }
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(props) {
      // do nothing when dataLength and key are unchanged
      if (this.props.key === props.key && this.props.dataLength === props.dataLength) return;
      this.actionTriggered = false; // update state when new data was sent in

      this.setState({
        showLoader: false,
        pullToRefreshThresholdBreached: false
      });
    }
  }, {
    key: "getScrollableTarget",
    value: function getScrollableTarget() {
      if (this.props.scrollableTarget instanceof HTMLElement) return this.props.scrollableTarget;

      if (typeof this.props.scrollableTarget === 'string') {
        return document.getElementById(this.props.scrollableTarget);
      }

      if (this.props.scrollableTarget === null) {
        console.warn("You are trying to pass scrollableTarget but it is null. This might\n        happen because the element may not have been added to DOM yet.\n        See https://github.com/ankeetmaini/react-infinite-scroll-component/issues/59 for more info.\n      ");
      }

      return null;
    }
  }, {
    key: "onStart",
    value: function onStart(evt) {
      if (this.lastScrollTop) return;
      this.dragging = true;
      this.startY = evt.pageY || evt.touches[0].pageY;
      this.currentY = this.startY;
      this._infScroll.style.willChange = "transform";
      this._infScroll.style.transition = "transform 0.2s cubic-bezier(0,0,0.31,1)";
    }
  }, {
    key: "onMove",
    value: function onMove(evt) {
      if (!this.dragging) return;
      this.currentY = evt.pageY || evt.touches[0].pageY; // user is scrolling down to up

      if (this.currentY < this.startY) return;

      if (this.currentY - this.startY >= this.props.pullDownToRefreshThreshold) {
        this.setState({
          pullToRefreshThresholdBreached: true
        });
      } // so you can drag upto 1.5 times of the maxPullDownDistance


      if (this.currentY - this.startY > this.maxPullDownDistance * 1.5) return;
      this._infScroll.style.overflow = "visible";
      this._infScroll.style.transform = "translate3d(0px, ".concat(this.currentY - this.startY, "px, 0px)");
    }
  }, {
    key: "onEnd",
    value: function onEnd(evt) {
      var _this2 = this;

      this.startY = 0;
      this.currentY = 0;
      this.dragging = false;

      if (this.state.pullToRefreshThresholdBreached) {
        this.props.refreshFunction && this.props.refreshFunction();
        this.actionTriggered = false;
        this.setState({
          showLoader: false,
          pullToRefreshThresholdBreached: false
        });
      }

      requestAnimationFrame(function () {
        // this._infScroll
        if (_this2._infScroll) {
          _this2._infScroll.style.overflow = "auto";
          _this2._infScroll.style.transform = "none";
          _this2._infScroll.style.willChange = "none";
        }
      });
    }
  }, {
    key: "isElementAtBottom",
    value: function isElementAtBottom(target) {
      var scrollThreshold = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0.8;
      var clientHeight = target === document.body || target === document.documentElement ? window.screen.availHeight : target.clientHeight;
      var threshold = (0, _threshold.parseThreshold)(scrollThreshold);

      if (threshold.unit === _threshold.ThresholdUnits.Pixel) {
        return target.scrollTop + clientHeight >= target.scrollHeight - threshold.value;
      }

      return target.scrollTop + clientHeight >= threshold.value / 100 * target.scrollHeight;
    }
  }, {
    key: "onScrollListener",
    value: function onScrollListener(event) {
      var _this3 = this;

      if (typeof this.props.onScroll === "function") {
        // Execute this callback in next tick so that it does not affect the
        // functionality of the library.
        setTimeout(function () {
          return _this3.props.onScroll(event);
        }, 0);
      }

      var target = this.props.height || this._scrollableNode ? event.target : document.documentElement.scrollTop ? document.documentElement : document.body; // return immediately if the action has already been triggered,
      // prevents multiple triggers.

      this.lastScrollTop = target.scrollTop;
      if (this.actionTriggered) return;
      var atBottom = this.isElementAtBottom(target, this.props.scrollThreshold); // call the `next` function in the props to trigger the next data fetch

      if (atBottom && this.props.hasMore) {
        this.actionTriggered = true;
        this.setState({
          showLoader: true
        });
        this.props.next();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this4 = this;

      var style = _objectSpread({
        height: this.props.height || "auto",
        overflow: "auto",
        WebkitOverflowScrolling: "touch"
      }, this.props.style);

      var hasChildren = this.props.hasChildren || !!(this.props.children && this.props.children.length); // because heighted infiniteScroll visualy breaks
      // on drag down as overflow becomes visible

      var outerDivStyle = this.props.pullDownToRefresh && this.props.height ? {
        overflow: "auto"
      } : {};
      return _react.default.createElement("div", {
        style: outerDivStyle
      }, _react.default.createElement("div", {
        className: "infinite-scroll-component ".concat(this.props.className || ''),
        ref: function ref(infScroll) {
          return _this4._infScroll = infScroll;
        },
        style: style
      }, this.props.pullDownToRefresh && _react.default.createElement("div", {
        style: {
          position: "relative"
        },
        ref: function ref(pullDown) {
          return _this4._pullDown = pullDown;
        }
      }, _react.default.createElement("div", {
        style: {
          position: "absolute",
          left: 0,
          right: 0,
          top: -1 * this.maxPullDownDistance
        }
      }, this.state.pullToRefreshThresholdBreached ? this.props.releaseToRefreshContent : this.props.pullDownToRefreshContent)), this.props.children, !this.state.showLoader && !hasChildren && this.props.hasMore && this.props.loader, this.state.showLoader && this.props.hasMore && this.props.loader, !this.props.hasMore && this.props.endMessage));
    }
  }]);

  return InfiniteScroll;
}(_react.Component);

exports.default = InfiniteScroll;
InfiniteScroll.defaultProps = {
  pullDownToRefreshContent: _react.default.createElement("h3", null, "Pull down to refresh"),
  releaseToRefreshContent: _react.default.createElement("h3", null, "Release to refresh"),
  pullDownToRefreshThreshold: 100,
  disableBrowserPullToRefresh: true
};
InfiniteScroll.propTypes = {
  next: _propTypes.default.func,
  hasMore: _propTypes.default.bool,
  children: _propTypes.default.node,
  loader: _propTypes.default.node.isRequired,
  scrollThreshold: _propTypes.default.oneOfType([_propTypes.default.number, _propTypes.default.string]),
  endMessage: _propTypes.default.node,
  style: _propTypes.default.object,
  height: _propTypes.default.number,
  scrollableTarget: _propTypes.default.node,
  hasChildren: _propTypes.default.bool,
  pullDownToRefresh: _propTypes.default.bool,
  pullDownToRefreshContent: _propTypes.default.node,
  releaseToRefreshContent: _propTypes.default.node,
  pullDownToRefreshThreshold: _propTypes.default.number,
  refreshFunction: _propTypes.default.func,
  onScroll: _propTypes.default.func,
  dataLength: _propTypes.default.number.isRequired,
  key: _propTypes.default.string
};