"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.parseThreshold = parseThreshold;
exports.ThresholdUnits = void 0;

require("core-js/modules/es6.regexp.match");

/* eslint-disable */
var ThresholdUnits = {
  Pixel: 'Pixel',
  Percent: 'Percent'
};
exports.ThresholdUnits = ThresholdUnits;
var defaultThreshold = {
  unit: ThresholdUnits.Percent,
  value: 0.8
};

function parseThreshold(scrollThreshold) {
  if (typeof scrollThreshold === "number") {
    return {
      unit: ThresholdUnits.Percent,
      value: scrollThreshold * 100
    };
  }

  if (typeof scrollThreshold === "string") {
    if (scrollThreshold.match(/^(\d*(\.\d+)?)px$/)) {
      return {
        unit: ThresholdUnits.Pixel,
        value: parseFloat(scrollThreshold)
      };
    }

    if (scrollThreshold.match(/^(\d*(\.\d+)?)%$/)) {
      return {
        unit: ThresholdUnits.Percent,
        value: parseFloat(scrollThreshold)
      };
    }

    console.warn('scrollThreshold format is invalid. Valid formats: "120px", "50%"...');
    return defaultThreshold;
  }

  console.warn('scrollThreshold should be string or number');
  return defaultThreshold;
}