"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ButtonControlProperties = ButtonControlProperties;
exports.default = void 0;

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/es6.object.set-prototype-of");

require("antd-mobile/es/button/style");

var _button = _interopRequireDefault(require("antd-mobile/es/button"));

require("core-js/modules/es6.function.name");

var _react = _interopRequireDefault(require("react"));

var _Control2 = _interopRequireDefault(require("../Control"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var ButtonControl =
/*#__PURE__*/
function (_Control) {
  _inherits(ButtonControl, _Control);

  function ButtonControl(props, context) {
    var _this;

    _classCallCheck(this, ButtonControl);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ButtonControl).call(this, props, context));
    _this.state = {
      type: 'button'
    };
    return _this;
  }

  _createClass(ButtonControl, [{
    key: "renderControl",
    value: function renderControl() {
      var _this$props = this.props,
          name = _this$props.name,
          type = _this$props.type,
          size = _this$props.size,
          disabled = _this$props.disabled,
          visible = _this$props.visible,
          onClick = _this$props.onClick;
      var options = {
        type: type,
        size: size
      };

      if (disabled) {
        options.disabled = disabled;
      }

      if (visible === false) {
        if (options.style == null) {
          options.style = {
            display: 'none'
          };
        } else {
          options.style.display = 'none';
        }
      }

      if (onClick) {
        options.onClick = function () {
          onClick();
        };
      }

      return _react.default.createElement(_button.default, options, name);
    }
  }]);

  return ButtonControl;
}(_Control2.default);

exports.default = ButtonControl;

function ButtonControlProperties(controlId, bindedFieldOptions) {
  return [{
    key: 'id',
    title: '控件ID',
    value: controlId,
    type: 'text',
    disabled: true,
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'style',
    title: '样式',
    value: '',
    type: 'codeModal',
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'name',
    title: '名称',
    value: '按钮',
    type: 'text',
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'type',
    title: '类型',
    value: 'primary',
    type: 'select',
    options: [{
      value: 'primary',
      label: 'primary'
    }, {
      value: 'ghost',
      label: 'ghost'
    }, {
      value: 'warning',
      label: 'warning'
    }],
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'size',
    title: '大小',
    value: 'large',
    type: 'select',
    options: [{
      value: 'large',
      label: 'large'
    }, {
      value: 'small',
      label: 'small'
    }],
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'isVisible',
    title: '是否可见',
    value: '',
    type: 'code',
    layout: {
      labelCol: {
        span: -1
      },
      wrapperCol: {
        span: 24
      }
    }
  }, {
    key: 'isEnabled',
    title: '是否可用',
    value: '',
    type: 'code',
    layout: {
      labelCol: {
        span: -1
      },
      wrapperCol: {
        span: 24
      }
    }
  }, {
    key: 'onClickEvent',
    title: '点击事件',
    value: '',
    type: 'code',
    layout: {
      labelCol: {
        span: -1
      },
      wrapperCol: {
        span: 24
      }
    }
  }];
}