"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createControlId = createControlId;
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

require("antd-mobile/dist/antd-mobile.less");

var _NavBarControl = _interopRequireWildcard(require("./NavBarControl"));

var _GridControl = _interopRequireWildcard(require("./GridControl"));

var _ListControl = _interopRequireWildcard(require("./ListControl"));

var _TextControl = _interopRequireWildcard(require("./TextControl"));

var _PickerControl = _interopRequireWildcard(require("./PickerControl"));

var _NumberControl = _interopRequireWildcard(require("./NumberControl"));

var _DatePickerControl = _interopRequireWildcard(require("./DatePickerControl"));

var _SearchPickerControl = _interopRequireWildcard(require("./SearchPickerControl"));

var _TextAreaControl = _interopRequireWildcard(require("./TextAreaControl"));

var _ButtonControl = _interopRequireWildcard(require("./ButtonControl"));

var _ContainerControl = _interopRequireWildcard(require("./ContainerControl"));

var _TabsControl = _interopRequireWildcard(require("./TabsControl"));

var _TabPaneControl = _interopRequireWildcard(require("./TabPaneControl"));

var _CommonDetailControl = _interopRequireWildcard(require("./CommonDetailControl"));

var _TabBarControl = _interopRequireWildcard(require("./TabBarControl"));

var _TabBarItemControl = _interopRequireWildcard(require("./TabBarItemControl"));

var _AntdListControl = _interopRequireWildcard(require("./AntdListControl"));

var _BpmTableControl = _interopRequireWildcard(require("./BpmTableControl"));

var _OperationLogsTableControl = _interopRequireWildcard(require("./OperationLogsTableControl"));

var _UploadTableControl = _interopRequireWildcard(require("./UploadTableControl"));

var _ImagePickerControl = _interopRequireWildcard(require("./ImagePickerControl"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function createControlId(type) {
  return "".concat(type, "-").concat(new Date().getTime());
}

var ControlFactory =
/*#__PURE__*/
function () {
  function ControlFactory() {
    _classCallCheck(this, ControlFactory);
  }

  _createClass(ControlFactory, [{
    key: "getControl",
    value: function getControl(controlName) {
      if (controlName == 'navBar') {
        return _NavBarControl.default;
      } else if (controlName == 'grid') {
        return _GridControl.default;
      } else if (controlName == 'list') {
        return _ListControl.default;
      } else if (controlName == 'text') {
        return _TextControl.default;
      } else if (controlName == 'picker') {
        return _PickerControl.default;
      } else if (controlName == 'number') {
        return _NumberControl.default;
      } else if (controlName == 'datePicker') {
        return _DatePickerControl.default;
      } else if (controlName == 'searchPicker') {
        return _SearchPickerControl.default;
      } else if (controlName == 'textarea') {
        return _TextAreaControl.default;
      } else if (controlName == 'button') {
        return _ButtonControl.default;
      } else if (controlName == 'container') {
        return _ContainerControl.default;
      } else if (controlName == 'tabs') {
        return _TabsControl.default;
      } else if (controlName == 'tabPane') {
        return _TabPaneControl.default;
      } else if (controlName == 'commonDetail') {
        return _CommonDetailControl.default;
      } else if (controlName == 'tabBar') {
        return _TabBarControl.default;
      } else if (controlName == 'tabBarItem') {
        return _TabBarItemControl.default;
      } else if (controlName == 'antdList') {
        return _AntdListControl.default;
      } else if (controlName == 'bpmTable') {
        return _BpmTableControl.default;
      } else if (controlName == 'operationLogsTable') {
        return _OperationLogsTableControl.default;
      } else if (controlName == 'uploadTable') {
        return _UploadTableControl.default;
      } else if (controlName == 'imagePicker') {
        return _ImagePickerControl.default;
      }
    }
  }, {
    key: "getControlInitProps",
    value: function getControlInitProps(controlName, controlId, bindedFieldOptions, dictList) {
      if (controlName == 'navBar') {
        return (0, _NavBarControl.NavBarControlProperties)(controlId);
      } else if (controlName == 'grid') {
        return (0, _GridControl.GridControlProperties)(controlId);
      } else if (controlName == 'list') {
        return (0, _ListControl.ListControlProperties)(controlId);
      } else if (controlName == 'text') {
        return (0, _TextControl.TextControlProperties)(controlId, bindedFieldOptions);
      } else if (controlName == 'picker') {
        return (0, _PickerControl.PickerControlProperties)(controlId, bindedFieldOptions, dictList);
      } else if (controlName == 'number') {
        return (0, _NumberControl.NumberControlProperties)(controlId, bindedFieldOptions);
      } else if (controlName == 'datePicker') {
        return (0, _DatePickerControl.DatePickerControlProperties)(controlId, bindedFieldOptions);
      } else if (controlName == 'searchPicker') {
        return (0, _SearchPickerControl.SearchPickerControlProperties)(controlId, bindedFieldOptions);
      } else if (controlName == 'textarea') {
        return (0, _TextAreaControl.TextAreaControlProperties)(controlId, bindedFieldOptions);
      } else if (controlName == 'button') {
        return (0, _ButtonControl.ButtonControlProperties)(controlId, bindedFieldOptions);
      } else if (controlName == 'container') {
        return (0, _ContainerControl.ContainerControlProperties)(controlId, bindedFieldOptions);
      } else if (controlName == 'tabs') {
        return (0, _TabsControl.TabsControlProperties)(controlId, bindedFieldOptions);
      } else if (controlName == 'tabPane') {
        return (0, _TabPaneControl.TabPaneControlProperties)(controlId, bindedFieldOptions);
      } else if (controlName == 'commonDetail') {
        return (0, _CommonDetailControl.CommonDetailControlProperties)(controlId, bindedFieldOptions);
      } else if (controlName == 'tabBar') {
        return (0, _TabBarControl.TabBarControlProperties)(controlId, bindedFieldOptions);
      } else if (controlName == 'tabBarItem') {
        return (0, _TabBarItemControl.TabBarItemControlProperties)(controlId, bindedFieldOptions);
      } else if (controlName == 'antdList') {
        return (0, _AntdListControl.AntdListControlProperties)(controlId, bindedFieldOptions);
      } else if (controlName == 'bpmTable') {
        return (0, _BpmTableControl.BpmTableControlProperties)(controlId, bindedFieldOptions);
      } else if (controlName == 'operationLogsTable') {
        return (0, _OperationLogsTableControl.OperationLogsTableControlProperties)(controlId, bindedFieldOptions);
      } else if (controlName == 'uploadTable') {
        return (0, _UploadTableControl.UploadTableControlProperties)(controlId, bindedFieldOptions);
      } else if (controlName == 'imagePicker') {
        return (0, _ImagePickerControl.ImagePickerControlProperties)(controlId, bindedFieldOptions);
        ;
      } else {
        return [];
      }
    }
  }, {
    key: "getControlCommonDetailInitProps",
    value: function getControlCommonDetailInitProps(controlName, controlId, bindedFieldOptions, dictList) {
      if (controlName == 'text') {
        var properties = (0, _TextControl.TextControlProperties)(controlId, bindedFieldOptions);
        return properties.filter(function (item) {
          return item.key != 'labelNumber';
        });
      } else if (controlName == 'number') {
        var _properties = (0, _NumberControl.NumberControlProperties)(controlId, bindedFieldOptions);

        return _properties.filter(function (item) {
          return item.key != 'labelNumber';
        });
      } else if (controlName == 'picker') {
        var _properties2 = (0, _PickerControl.PickerControlProperties)(controlId, bindedFieldOptions, dictList);

        return _properties2.filter(function (item) {
          return item.key != 'labelNumber';
        });
      } else if (controlName == 'datePicker') {
        return (0, _DatePickerControl.DatePickerControlProperties)(controlId, bindedFieldOptions);
      } else if (controlName == 'searchPicker') {
        return (0, _SearchPickerControl.SearchPickerControlProperties)(controlId, bindedFieldOptions);
      } else if (controlName == 'textarea') {
        var _properties3 = (0, _TextAreaControl.TextAreaControlProperties)(controlId, bindedFieldOptions);

        return _properties3.filter(function (item) {
          return item.key != 'labelNumber';
        });
      } else {
        return [];
      }
    }
  }]);

  return ControlFactory;
}();

var _default = new ControlFactory();

exports.default = _default;