"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.GridControlProperties = GridControlProperties;
exports.default = void 0;

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/es6.object.assign");

require("core-js/modules/es6.object.set-prototype-of");

require("antd-mobile/es/grid/style");

var _grid = _interopRequireDefault(require("antd-mobile/es/grid"));

var _react = _interopRequireDefault(require("react"));

var _Control2 = _interopRequireDefault(require("../Control"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var GridControl =
/*#__PURE__*/
function (_Control) {
  _inherits(GridControl, _Control);

  function GridControl(props, context) {
    var _this;

    _classCallCheck(this, GridControl);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(GridControl).call(this, props, context));
    _this.state = {
      type: 'grid'
    };
    return _this;
  }

  _createClass(GridControl, [{
    key: "renderControl",
    value: function renderControl() {
      var _this$props = this.props,
          data = _this$props.data,
          columnNum = _this$props.columnNum,
          onClick = _this$props.onClick,
          hasLine = _this$props.hasLine;
      var options = {};

      if (onClick) {
        options.onClick = onClick;
      }

      return _react.default.createElement(_grid.default, _extends({
        data: data,
        columnNum: columnNum < 2 ? 2 : columnNum,
        hasLine: hasLine == '1',
        activeStyle: false
      }, options));
    }
  }]);

  return GridControl;
}(_Control2.default);

exports.default = GridControl;

function GridControlProperties(controlId) {
  return [{
    key: 'id',
    title: '控件ID',
    value: controlId,
    type: 'text',
    disabled: true,
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'style',
    title: '样式',
    value: '',
    type: 'codeModal',
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'data',
    title: 'data',
    value: [],
    type: 'commonOptions',
    fields: [{
      key: 'icon',
      title: '图标'
    }, {
      key: 'text',
      title: '标题',
      isNameField: 1
    }],
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'columnNum',
    title: '列数',
    value: 4,
    type: 'number',
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'hasLine',
    title: '是否有边框',
    value: '1',
    type: 'select',
    options: [{
      value: '0',
      label: '否'
    }, {
      value: '1',
      label: '是'
    }],
    layout: {
      labelCol: {
        span: 10
      },
      wrapperCol: {
        span: 14
      }
    }
  }, {
    key: 'onClick',
    title: '点击事件',
    value: '',
    type: 'code',
    layout: {
      labelCol: {
        span: -1
      },
      wrapperCol: {
        span: 24
      }
    }
  }];
}