"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ImagePickerControlProperties = ImagePickerControlProperties;
exports.default = void 0;

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/es6.object.set-prototype-of");

require("antd-mobile/es/list/style");

var _list = _interopRequireDefault(require("antd-mobile/es/list"));

require("antd-mobile/es/image-picker/style");

var _imagePicker = _interopRequireDefault(require("antd-mobile/es/image-picker"));

require("core-js/modules/es6.function.name");

var _react = _interopRequireDefault(require("react"));

var _FormControl2 = _interopRequireDefault(require("../FormControl"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var ImagePickerControl =
/*#__PURE__*/
function (_FormControl) {
  _inherits(ImagePickerControl, _FormControl);

  function ImagePickerControl(props, context) {
    var _this;

    _classCallCheck(this, ImagePickerControl);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ImagePickerControl).call(this, props, context));
    _this.state = {
      type: 'imagePicker'
    };
    return _this;
  }

  _createClass(ImagePickerControl, [{
    key: "renderFormControl",
    value: function renderFormControl() {
      var _this$props = this.props,
          value = _this$props.value,
          name = _this$props.name,
          operationType = _this$props.operationType,
          _onChange = _this$props.onChange;
      var files = [];
      var imgUrl = '';

      if (value != null && value != '') {
        imgUrl = value;
        files.push({
          url: imgUrl,
          id: value
        });
      }

      var extra = null;

      if (operationType == 'V') {
        extra = _react.default.createElement("img", {
          src: imgUrl,
          style: {
            width: '85px',
            height: '85px'
          }
        });
      } else {
        extra = _react.default.createElement(_imagePicker.default, {
          files: files,
          length: 1,
          onChange: function onChange(fs, ot, index) {
            _onChange(fs, ot, index);
          },
          selectable: files.length < 1,
          style: {
            width: '98px'
          }
        });
      }

      return _react.default.createElement(_list.default.Item, null, _react.default.createElement("span", {
        style: {
          color: operationType == 'V' ? '#bbb' : 'black'
        }
      }, name), _react.default.createElement("div", {
        style: {
          display: 'inline-block',
          marginLeft: 'calc(100% - 135px)'
        }
      }, extra));
    }
  }]);

  return ImagePickerControl;
}(_FormControl2.default);

exports.default = ImagePickerControl;

function ImagePickerControlProperties(controlId, bindedFieldOptions) {
  return [{
    key: 'id',
    title: '控件ID',
    value: controlId,
    type: 'text',
    disabled: true,
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'bindField',
    title: '绑定字段',
    value: '',
    type: 'select',
    options: bindedFieldOptions,
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'name',
    title: '名称',
    value: '名称',
    type: 'text',
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'onChangeEvent',
    title: '值改变事件',
    value: '',
    type: 'code',
    layout: {
      labelCol: {
        span: -1
      },
      wrapperCol: {
        span: 24
      }
    }
  }, {
    key: 'isVisible',
    title: '是否可见',
    value: '',
    type: 'code',
    layout: {
      labelCol: {
        span: -1
      },
      wrapperCol: {
        span: 24
      }
    }
  }];
}