"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ListControlProperties = ListControlProperties;
exports.default = void 0;

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/es6.object.set-prototype-of");

require("antd-mobile/es/picker/style");

var _picker = _interopRequireDefault(require("antd-mobile/es/picker"));

require("antd-mobile/es/date-picker/style");

var _datePicker = _interopRequireDefault(require("antd-mobile/es/date-picker"));

require("antd-mobile/es/input-item/style");

var _inputItem = _interopRequireDefault(require("antd-mobile/es/input-item"));

require("core-js/modules/es6.function.name");

require("core-js/modules/es6.regexp.replace");

require("antd-mobile/es/drawer/style");

var _drawer = _interopRequireDefault(require("antd-mobile/es/drawer"));

require("antd-mobile/es/button/style");

var _button = _interopRequireDefault(require("antd-mobile/es/button"));

require("antd-mobile/es/list/style");

var _list = _interopRequireDefault(require("antd-mobile/es/list"));

require("core-js/modules/es6.regexp.search");

var _react = _interopRequireDefault(require("react"));

var _dva = require("dva");

var _Control2 = _interopRequireDefault(require("../Control"));

var _index = _interopRequireDefault(require("../InfiniteScroll/index"));

var _dictUtil = _interopRequireDefault(require("../../../dictUtil"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var ListControl =
/*#__PURE__*/
function (_Control) {
  _inherits(ListControl, _Control);

  function ListControl(props, context) {
    var _this;

    _classCallCheck(this, ListControl);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ListControl).call(this, props, context));
    _this.state = {
      type: 'list',
      listData: [],
      totalCount: 0,
      loading: false
    };
    return _this;
  }

  _createClass(ListControl, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.search();
    }
  }, {
    key: "search",
    value: function search(params) {
      var onSearch = this.props.onSearch;

      if (onSearch) {
        onSearch(params);
      }
    }
  }, {
    key: "renderControl",
    value: function renderControl() {
      var _this2 = this;

      var _this$props = this.props,
          dataSource = _this$props.dataSource,
          filterColumns = _this$props.filterColumns,
          queryOpenChange = _this$props.queryOpenChange,
          queryViewVisible = _this$props.queryViewVisible,
          designmode = _this$props.designmode,
          searchParams = _this$props.searchParams,
          renderListItem = _this$props.renderListItem,
          dispatch = _this$props.dispatch,
          pageId = _this$props.pageId,
          totalCount = _this$props.totalCount,
          loading = _this$props.loading;
      var items = [];

      var _loop = function _loop(i) {
        var column = filterColumns[i];

        if (column.inputType == 'text') {
          items.push(_react.default.createElement(_inputItem.default, {
            key: column.key,
            value: searchParams[column.key] != null && searchParams[column.key] != '' ? searchParams[column.key].like.replace(/\%/g, '') : '',
            clear: true,
            onChange: function onChange(val) {
              if (val != null && val != '') {
                searchParams[column.key] = {
                  like: "%".concat(val, "%")
                };
              } else {
                delete searchParams[column.key];
              }

              _this2.forceUpdate();
            }
          }, column.name));
        } else if (column.inputType == 'date') {
          items.push(_react.default.createElement(_datePicker.default, {
            key: column.key,
            value: searchParams[column.key] != null ? new Date(searchParams[column.key].like.replace(/\%/g, '').replace(/\-/g, '/')) : '',
            mode: "date",
            onChange: function onChange(val) {
              var year = val.getFullYear();
              var month = val.getMonth() + 1;
              var day = val.getDate();

              if (month < 10) {
                month = '0' + month;
              }

              if (day < 10) {
                day = '0' + day;
              }

              searchParams[column.key] = {
                like: "%".concat(year + '-' + month + '-' + day, "%")
              };

              _this2.forceUpdate();
            }
          }, _react.default.createElement(_list.default.Item, {
            arrow: "horizontal"
          }, column.name)));
        } else if (column.inputType == 'dict') {
          var dict = _this2.props.dict;

          if (dict != null) {
            items.push(_react.default.createElement(_picker.default, {
              value: searchParams[column.key] != null && searchParams[column.key] != '' ? searchParams[column.key] : '',
              data: (0, _dictUtil.default)(dict[column.dictCode]),
              cols: 1,
              onChange: function onChange(val) {
                if (val != null && val != '') {
                  searchParams[column.key] = val;
                } else {
                  delete searchParams[column.key];
                }

                _this2.forceUpdate();
              }
            }, _react.default.createElement(_list.default.Item, {
              arrow: "horizontal"
            }, column.name)));
          }
        }
      };

      for (var i = 0; i < filterColumns.length; i += 1) {
        _loop(i);
      }

      var sidebar = _react.default.createElement("div", {
        style: {
          height: '100%'
        }
      }, _react.default.createElement(_list.default, null, items), _react.default.createElement(_button.default, {
        type: "primary",
        onClick: function onClick() {
          searchParams.page_no = 1;
          dispatch({
            type: 'page/stateChange',
            payload: {
              pageId: pageId,
              params: {
                tableData: [],
                totalCount: 0,
                queryViewVisible: false
              }
            }
          });

          _this2.search(); // this.state.listData = [];
          // this.state.searchParams.page = 0;
          // this.search();
          // this.handleFilterVisible();

        }
      }, "\u67E5\u8BE2"));

      var children = _react.default.createElement("div", {
        id: "scrollableDiv",
        style: {
          paddingTop: 0,
          flex: 1,
          height: '100%',
          overflow: 'auto',
          backgroundColor: 'white'
        }
      }, _react.default.createElement(_index.default, {
        dataLength: dataSource.length // This is important field to render the next data
        ,
        next: function next() {
          searchParams.page_no += 1;
          dispatch({
            type: 'page/stateChange',
            payload: {
              pageId: pageId,
              params: {
                searchParams: searchParams
              }
            }
          });

          _this2.search();
        },
        loader: _react.default.createElement("h4", {
          style: {
            textAlign: 'center'
          }
        }, "\u52A0\u8F7D\u4E2D..."),
        hasMore: searchParams.page_size * searchParams.page_no < totalCount,
        scrollableTarget: "scrollableDiv",
        endMessage: _react.default.createElement("div", {
          style: {
            textAlign: 'center'
          }
        }, _react.default.createElement("b", null, loading ? _react.default.createElement("div", {
          style: {
            textAlign: 'center'
          }
        }, "\u52A0\u8F7D\u4E2D...") : _react.default.createElement("div", {
          style: {
            textAlign: 'center'
          }
        }, "\u5DF2\u52A0\u8F7D\u5168\u90E8"))) // below props only if you need pull down functionality
        ,
        refreshFunction: function refreshFunction() {
          searchParams.page_size = 10;
          searchParams.page_no = 1;
          dispatch({
            type: 'page/stateChange',
            payload: {
              pageId: pageId,
              params: {
                tableData: [],
                searchParams: searchParams
              }
            }
          });

          _this2.search();
        },
        pullDownToRefresh: true,
        pullDownToRefreshContent: _react.default.createElement("h3", {
          style: {
            textAlign: 'center'
          }
        }, "\u2193 \u4E0B\u62C9\u5237\u65B0"),
        releaseToRefreshContent: _react.default.createElement("div", {
          style: {
            textAlign: 'center'
          }
        }, "\u52A0\u8F7D\u4E2D...")
      }, dataSource.map(function (item) {
        return renderListItem(item);
      })));

      if (designmode == 'false') {
        children = _react.default.createElement(_drawer.default, {
          className: "my-drawer",
          style: {
            flex: 1,
            overflowX: 'hidden',
            height: '100%'
          },
          contentStyle: {
            height: '100%'
          },
          position: "right",
          sidebar: sidebar,
          open: queryViewVisible,
          onOpenChange: queryOpenChange
        }, children);
      }

      return children;
    }
  }]);

  return ListControl;
}(_Control2.default);

function mapStateToProps(state) {
  var page = state.page;
  return {
    page: page
  };
}

var _default = (0, _dva.connect)(mapStateToProps)(ListControl);

exports.default = _default;

function ListControlProperties(controlId) {
  return [{
    key: 'id',
    title: '控件ID',
    value: controlId,
    type: 'text',
    disabled: true,
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'style',
    title: '样式',
    value: '',
    type: 'codeModal',
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'filterColumns',
    title: '过滤项',
    value: [],
    type: 'filterColumns',
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'renderListItemEvent',
    title: '渲染事件',
    value: '',
    type: 'code',
    layout: {
      labelCol: {
        span: -1
      },
      wrapperCol: {
        span: 24
      }
    }
  }, {
    key: 'onSearchEvent',
    title: '查询方法',
    value: '',
    type: 'code',
    layout: {
      labelCol: {
        span: -1
      },
      wrapperCol: {
        span: 24
      }
    }
  }];
}