"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PickerControlProperties = PickerControlProperties;
exports.DetailTableProperties = DetailTableProperties;
exports.default = void 0;

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/es6.object.assign");

require("core-js/modules/es6.object.set-prototype-of");

require("core-js/modules/es6.array.find");

require("antd-mobile/es/modal/style");

var _modal = _interopRequireDefault(require("antd-mobile/es/modal"));

require("antd-mobile/es/button/style");

var _button = _interopRequireDefault(require("antd-mobile/es/button"));

require("antd-mobile/es/list/style");

var _list = _interopRequireDefault(require("antd-mobile/es/list"));

require("antd-mobile/es/search-bar/style");

var _searchBar = _interopRequireDefault(require("antd-mobile/es/search-bar"));

require("core-js/modules/es6.function.name");

var _react = _interopRequireDefault(require("react"));

var _FormControl2 = _interopRequireDefault(require("../FormControl"));

var _InfiniteScroll = _interopRequireDefault(require("../InfiniteScroll"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var PickerControl =
/*#__PURE__*/
function (_FormControl) {
  _inherits(PickerControl, _FormControl);

  function PickerControl(props, context) {
    var _this;

    _classCallCheck(this, PickerControl);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(PickerControl).call(this, props, context));
    _this.state = {
      type: 'picker',
      keyword: '',
      modalVisible: false,
      options: null
    };
    return _this;
  }

  _createClass(PickerControl, [{
    key: "open",
    value: function open() {
      this.setState({
        modalVisible: true
      });
    }
  }, {
    key: "clear",
    value: function clear() {
      this.setState({
        keyword: '',
        modalVisible: false
      });
    }
  }, {
    key: "renderModal",
    value: function renderModal() {
      var _this2 = this;

      var _this$props = this.props,
          onChange = _this$props.onChange,
          name = _this$props.name,
          dataFilter = _this$props.dataFilter;

      if (this.state.options == null) {
        this.state.options = this.props.options;
      }

      var _this$state = this.state,
          modalVisible = _this$state.modalVisible,
          options = _this$state.options;
      var formOptions = this.getFormOptions();

      if (formOptions.readOnly) {
        formOptions.disabled = formOptions.readOnly;
      }

      if (formOptions.value) {
        formOptions.value = [formOptions.value];
      }

      var newOptions = JSON.parse(JSON.stringify(options));

      if (dataFilter) {
        newOptions = dataFilter(options);
      }

      return _react.default.createElement(_modal.default, {
        title: null,
        popup: true,
        visible: modalVisible,
        onClose: function onClose() {
          return _this2.clear();
        },
        animationType: "slide-up",
        style: {
          height: '100%'
        },
        bodyStyle: {
          display: 'flex',
          flexDirection: 'column',
          height: 'calc(100% - 39px)'
        }
      }, _react.default.createElement(_searchBar.default, {
        placeholder: "\u6839\u636E\u5173\u952E\u5B57\u67E5\u8BE2",
        onSubmit: function onSubmit(val) {
          console.log(val);

          if (val != '') {
            _this2.state.options = options.filter(function (item) {
              return item.value.indexOf(val) != -1 || item.label.indexOf(val) != -1;
            });
          } else {
            _this2.state.options = _this2.props.options;
          }

          _this2.forceUpdate();
        }
      }), _react.default.createElement("div", {
        id: "scrollableDiv",
        style: {
          paddingTop: 0,
          flex: 1,
          height: '100%',
          overflow: 'auto',
          backgroundColor: 'white'
        }
      }, _react.default.createElement(_list.default, null, newOptions.map(function (item, inx) {
        return _react.default.createElement(_list.default.Item, {
          key: inx,
          onClick: function onClick() {
            onChange(item.value);

            _this2.clear();
          }
        }, item.label);
      }))), _react.default.createElement(_button.default, {
        type: "warning",
        onClick: function onClick() {
          return _this2.clear();
        }
      }, "\u5173\u95ED"));
    }
  }, {
    key: "renderFormControl",
    value: function renderFormControl() {
      var _this3 = this;

      var _this$props2 = this.props,
          name = _this$props2.name,
          formData = _this$props2.formData,
          disabled = _this$props2.disabled,
          visibleField = _this$props2.visibleField;
      var modalVisible = this.state.modalVisible;
      var formOptions = this.getFormOptions();

      if (formData != null && visibleField != null) {
        formOptions.value = formData[visibleField];
      }

      if (formOptions.value && this.props.options != null) {
        var op = this.props.options.find(function (item) {
          return item.value == formOptions.value;
        });

        if (op != null) {
          formOptions.value = op.label;
        }
      }

      var options = {};

      if (formOptions.readOnly !== true && !disabled && !formOptions.disabled) {
        options.onClick = function () {
          _this3.open();
        };
      }

      if (formOptions.disabled === true) {
        options.disabled = formOptions.disabled;
      }

      return _react.default.createElement("div", null, _react.default.createElement(_list.default.Item, _extends({
        arrow: "horizontal",
        extra: formOptions.value
      }, options), name), modalVisible ? this.renderModal() : '');
    }
  }]);

  return PickerControl;
}(_FormControl2.default);

exports.default = PickerControl;

function PickerControlProperties(controlId, bindedFieldOptions, dictList) {
  var dictOptions = [];

  for (var i = 0; i < dictList.length; i += 1) {
    dictOptions.push({
      value: dictList[i].f_dictcode,
      label: dictList[i].f_dictname
    });
  }

  return [{
    key: 'id',
    title: '控件ID',
    value: controlId,
    type: 'text',
    disabled: true,
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'bindField',
    title: '绑定字段',
    value: '',
    type: 'select',
    options: bindedFieldOptions,
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'name',
    title: '名称',
    value: '选择器',
    type: 'text',
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'labelNumber',
    title: '名称宽度（2-7）',
    value: 5,
    type: 'number',
    layout: {
      labelCol: {
        span: 11
      },
      wrapperCol: {
        span: 13
      }
    }
  }, {
    key: 'dictCode',
    title: '数据字典',
    value: [],
    type: 'select',
    options: dictOptions,
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'options',
    title: '选项',
    value: [],
    type: 'selectOptions',
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'defaultValue',
    title: '默认值',
    value: '',
    type: 'text',
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'dataFilterEvent',
    title: '数据过滤事件',
    value: '',
    type: 'code',
    layout: {
      labelCol: {
        span: -1
      },
      wrapperCol: {
        span: 24
      }
    }
  }, {
    key: 'isEnabled',
    title: '是否可用',
    value: '',
    type: 'code',
    layout: {
      labelCol: {
        span: -1
      },
      wrapperCol: {
        span: 24
      }
    }
  }, {
    key: 'isVisible',
    title: '是否可见',
    value: '',
    type: 'code',
    layout: {
      labelCol: {
        span: -1
      },
      wrapperCol: {
        span: 24
      }
    }
  }, {
    key: 'isRequired',
    title: '是否必填',
    value: '0',
    type: 'select',
    options: [{
      value: '0',
      label: '否'
    }, {
      value: '1',
      label: '是'
    }],
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'onChangeEvent',
    title: '值改变事件',
    value: '',
    type: 'code',
    layout: {
      labelCol: {
        span: -1
      },
      wrapperCol: {
        span: 24
      }
    }
  }];
}

function DetailTableProperties(controlId, bindedFieldOptions, dictList) {
  var dictOptions = [];

  for (var i = 0; i < dictList.length; i += 1) {
    dictOptions.push({
      value: dictList[i].f_dictcode,
      label: dictList[i].f_dictname
    });
  }

  return [{
    key: 'id',
    title: '控件ID',
    value: controlId,
    type: 'text',
    disabled: true,
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'bindField',
    title: '绑定字段',
    value: '',
    type: 'select',
    options: bindedFieldOptions,
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'name',
    title: '名称',
    value: '下拉框',
    type: 'text',
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'width',
    title: '宽度',
    value: 100,
    type: 'number',
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'dictCode',
    title: '数据字典',
    value: [],
    type: 'select',
    options: dictOptions,
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'options',
    title: '选项',
    value: [],
    type: 'selectOptions',
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'isEnabled',
    title: '是否可用',
    value: '',
    type: 'code',
    layout: {
      labelCol: {
        span: -1
      },
      wrapperCol: {
        span: 24
      }
    }
  }, {
    key: 'isVisible',
    title: '是否显示',
    value: '1',
    type: 'select',
    options: [{
      value: '0',
      label: '否'
    }, {
      value: '1',
      label: '是'
    }],
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'isRequired',
    title: '是否必填',
    value: '0',
    type: 'select',
    options: [{
      value: '0',
      label: '否'
    }, {
      value: '1',
      label: '是'
    }],
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'onChangeEvent',
    title: '值改变事件',
    value: '',
    type: 'code',
    layout: {
      labelCol: {
        span: -1
      },
      wrapperCol: {
        span: 24
      }
    }
  }];
}