"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TabBarItemControlProperties = TabBarItemControlProperties;
exports.default = void 0;

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/es6.object.set-prototype-of");

require("antd-mobile/es/tab-bar/style");

var _tabBar = _interopRequireDefault(require("antd-mobile/es/tab-bar"));

var _react = _interopRequireDefault(require("react"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var TabBarItemControl =
/*#__PURE__*/
function (_React$Component) {
  _inherits(TabBarItemControl, _React$Component);

  function TabBarItemControl(props, context) {
    var _this;

    _classCallCheck(this, TabBarItemControl);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(TabBarItemControl).call(this, props, context));
    _this.state = {
      type: 'tabBarItem'
    };
    return _this;
  }

  _createClass(TabBarItemControl, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          id = _this$props.id,
          onDrop = _this$props.onDrop,
          onDragOver = _this$props.onDragOver,
          title = _this$props.title,
          icon = _this$props.icon,
          badgeCount = _this$props.badgeCount,
          selectedIcon = _this$props.selectedIcon,
          selected = _this$props.selected,
          onPress = _this$props.onPress,
          children = _this$props.children,
          designmode = _this$props.designmode;
      var style = {};

      if (designmode == 'true') {
        style.paddingBottom = '20px';
      }

      style.height = '100%';
      return _react.default.createElement("div", {
        id: id,
        onDrop: onDrop,
        onDragOver: onDragOver,
        style: style
      }, _react.default.createElement(_tabBar.default.Item, {
        title: title,
        key: id,
        icon: icon,
        badge: badgeCount,
        selectedIcon: selectedIcon,
        selected: selected,
        onPress: onPress
      }, children));
    }
  }]);

  return TabBarItemControl;
}(_react.default.Component);

exports.default = TabBarItemControl;

function TabBarItemControlProperties(controlId, bindedFieldOptions) {
  return [{
    key: 'id',
    title: '控件ID',
    value: controlId,
    type: 'text',
    disabled: true,
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'key',
    title: 'key',
    value: '',
    type: 'text',
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'title',
    title: 'title',
    value: '',
    type: 'text',
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'icon',
    title: 'icon',
    value: '',
    type: 'codeModal',
    layout: {
      labelCol: {
        span: -1
      },
      wrapperCol: {
        span: 24
      }
    }
  }, {
    key: 'badgeCount',
    title: 'badge',
    value: '',
    type: 'codeModal',
    layout: {
      labelCol: {
        span: -1
      },
      wrapperCol: {
        span: 24
      }
    }
  }, {
    key: 'selectedIcon',
    title: 'selectedIcon',
    value: '',
    type: 'codeModal',
    layout: {
      labelCol: {
        span: -1
      },
      wrapperCol: {
        span: 24
      }
    }
  }, {
    key: 'selectedEvent',
    title: '是否选中',
    value: '',
    type: 'codeModal',
    layout: {
      labelCol: {
        span: -1
      },
      wrapperCol: {
        span: 24
      }
    }
  }, {
    key: 'onPressEvent',
    title: '点击事件',
    value: '',
    type: 'codeModal',
    layout: {
      labelCol: {
        span: -1
      },
      wrapperCol: {
        span: 24
      }
    }
  }];
}