"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TextAreaControlProperties = TextAreaControlProperties;
exports.default = void 0;

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/es6.object.assign");

require("core-js/modules/es6.object.set-prototype-of");

require("antd-mobile/es/textarea-item/style");

var _textareaItem = _interopRequireDefault(require("antd-mobile/es/textarea-item"));

require("core-js/modules/es6.function.name");

var _react = _interopRequireDefault(require("react"));

var _FormControl2 = _interopRequireDefault(require("../FormControl"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var TextAreaControl =
/*#__PURE__*/
function (_FormControl) {
  _inherits(TextAreaControl, _FormControl);

  function TextAreaControl(props, context) {
    var _this;

    _classCallCheck(this, TextAreaControl);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(TextAreaControl).call(this, props, context));
    _this.state = {
      type: 'textArea'
    };
    return _this;
  }

  _createClass(TextAreaControl, [{
    key: "renderFormControl",
    value: function renderFormControl() {
      var _this$props = this.props,
          name = _this$props.name,
          rows = _this$props.rows,
          labelNumber = _this$props.labelNumber,
          _onChange = _this$props.onChange;
      var options = this.getFormOptions();
      return _react.default.createElement(_textareaItem.default, _extends({
        clear: true,
        title: name,
        rows: rows
      }, options, {
        labelNumber: labelNumber,
        onChange: function onChange(val) {
          _onChange(val);
        }
      }));
    }
  }]);

  return TextAreaControl;
}(_FormControl2.default);

exports.default = TextAreaControl;

function TextAreaControlProperties(controlId, bindedFieldOptions) {
  return [{
    key: 'id',
    title: '控件ID',
    value: controlId,
    type: 'text',
    disabled: true,
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'bindField',
    title: '绑定字段',
    value: '',
    type: 'select',
    options: bindedFieldOptions,
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'name',
    title: '名称',
    value: '文本框',
    type: 'text',
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'rows',
    title: '显示行数',
    value: 2,
    type: 'number',
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'labelNumber',
    title: '名称宽度（2-7）',
    value: 5,
    type: 'number',
    layout: {
      labelCol: {
        span: 11
      },
      wrapperCol: {
        span: 13
      }
    }
  }, {
    key: 'defaultValue',
    title: '默认值',
    value: '',
    type: 'text',
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'isEnabled',
    title: '是否可用',
    value: '',
    type: 'code',
    layout: {
      labelCol: {
        span: -1
      },
      wrapperCol: {
        span: 24
      }
    }
  }, {
    key: 'isVisible',
    title: '是否可见',
    value: '',
    type: 'code',
    layout: {
      labelCol: {
        span: -1
      },
      wrapperCol: {
        span: 24
      }
    }
  }, {
    key: 'isRequired',
    title: '是否必填',
    value: '0',
    type: 'select',
    options: [{
      value: '0',
      label: '否'
    }, {
      value: '1',
      label: '是'
    }],
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'onChangeEvent',
    title: '值改变事件',
    value: '',
    type: 'code',
    layout: {
      labelCol: {
        span: -1
      },
      wrapperCol: {
        span: 24
      }
    }
  }];
}