"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es6.object.keys");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.array.find");

require("antd-mobile/es/toast/style");

var _toast = _interopRequireDefault(require("antd-mobile/es/toast"));

require("core-js/modules/es6.regexp.replace");

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

require("regenerator-runtime/runtime");

var _effects = require("redux-saga/effects");

var _base = _interopRequireDefault(require("../base"));

var _service = require("../service");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var page = {
  namespace: 'page',
  state: {
    dict: []
  },
  effects: {
    loadDesign:
    /*#__PURE__*/
    _regenerator.default.mark(function loadDesign(_ref, _ref2) {
      var payload, call, put, requestProject, pageId, param, rtnData, data, entity;
      return _regenerator.default.wrap(function loadDesign$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              payload = _ref.payload;
              call = _ref2.call, put = _ref2.put;
              requestProject = payload.requestProject;
              pageId = payload.pageId;
              param = {
                url: "/".concat(requestProject, "/rest?com_id=0&method=design.page.get"),
                params: {
                  f_id: pageId
                }
              };
              _context.next = 7;
              return call(_service.post, param, put);

            case 7:
              rtnData = _context.sent;

              if (!(rtnData != null && rtnData['design_page'] != null)) {
                _context.next = 20;
                break;
              }

              data = rtnData['design_page'];
              param = {
                url: "/".concat(requestProject, "/rest?com_id=0&method=design.entity.get"),
                params: {
                  f_id: data.binded_entity_id,
                  fields: 'f_id,binded_entity_id,page_name,table_name,process_key,fields'
                }
              };
              _context.next = 13;
              return call(_service.post, param, put);

            case 13:
              rtnData = _context.sent;

              if (!(rtnData != null && rtnData['design_entity'] != null)) {
                _context.next = 20;
                break;
              }

              entity = rtnData['design_entity'];
              _context.next = 18;
              return put({
                type: 'loadDesignSuccess',
                payload: {
                  pageId: pageId,
                  pageName: data.page_name,
                  isClearState: data.is_clear_state,
                  pageJson: JSON.parse(data.page_json),
                  bindedEntity: entity
                }
              });

            case 18:
              localStorage.setItem("".concat(pageId, "_page_").concat(data.version), JSON.stringify(data));
              localStorage.setItem("".concat(pageId, "_entity"), JSON.stringify(entity));

            case 20:
            case "end":
              return _context.stop();
          }
        }
      }, loadDesign, this);
    }),
    loadDict:
    /*#__PURE__*/
    _regenerator.default.mark(function loadDict(_ref3, _ref4) {
      var payload, call, put, requestProject, param, rtnData;
      return _regenerator.default.wrap(function loadDict$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              payload = _ref3.payload;
              call = _ref4.call, put = _ref4.put;
              requestProject = payload.requestProject;
              param = {
                url: "/".concat(requestProject, "/rest?com_id=0&method=").concat(requestProject, ".dict.searchDict"),
                params: {}
              };
              _context2.next = 6;
              return call(_service.post, param, put);

            case 6:
              rtnData = _context2.sent;

              if (!(rtnData != null)) {
                _context2.next = 10;
                break;
              }

              _context2.next = 10;
              return put({
                type: 'loadDictSuccess',
                payload: {
                  data: rtnData
                }
              });

            case 10:
            case "end":
              return _context2.stop();
          }
        }
      }, loadDict, this);
    }),
    search:
    /*#__PURE__*/
    _regenerator.default.mark(function search(_ref5, _ref6) {
      var payload, call, put, response, url, pageId, state, pageState, searchParams, param, rtnData;
      return _regenerator.default.wrap(function search$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              payload = _ref5.payload;
              call = _ref6.call, put = _ref6.put;
              response = payload.response;
              url = payload.url;
              pageId = payload.pageId;
              _context3.next = 7;
              return (0, _effects.select)();

            case 7:
              state = _context3.sent;
              pageState = state['page'][pageId];
              searchParams = pageState.searchParams;

              if (searchParams == null) {
                searchParams = {};
              }

              param = {
                url: url,
                params: _objectSpread({
                  order_field: 'f_createdate',
                  order_direction: 'desc'
                }, searchParams, payload.params)
              };
              _context3.next = 14;
              return call(_service.post, param, put);

            case 14:
              rtnData = _context3.sent;

              if (!(rtnData != null && rtnData[response] != null)) {
                _context3.next = 18;
                break;
              }

              _context3.next = 18;
              return put({
                type: 'searchSuccess',
                payload: {
                  pageId: pageId,
                  data: rtnData[response],
                  totalCount: rtnData.total_results
                }
              });

            case 18:
            case "end":
              return _context3.stop();
          }
        }
      }, search, this);
    }),
    searchTreeData:
    /*#__PURE__*/
    _regenerator.default.mark(function searchTreeData(_ref7, _ref8) {
      var payload, call, put, url, response, pageId, param, rtnData;
      return _regenerator.default.wrap(function searchTreeData$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              payload = _ref7.payload;
              call = _ref8.call, put = _ref8.put;
              url = payload.url, response = payload.response, pageId = payload.pageId;
              param = {
                url: url,
                params: _objectSpread({
                  order_field: 'f_createdate',
                  order_direction: 'desc'
                }, payload.params)
              };
              _context4.next = 6;
              return call(_service.post, param, put);

            case 6:
              rtnData = _context4.sent;

              if (!(rtnData != null && rtnData[response] != null)) {
                _context4.next = 10;
                break;
              }

              _context4.next = 10;
              return put({
                type: 'searchTreeDataSuccess',
                payload: {
                  pageId: pageId,
                  data: rtnData[response],
                  totalCount: rtnData.total_results
                }
              });

            case 10:
            case "end":
              return _context4.stop();
          }
        }
      }, searchTreeData, this);
    }),
    save:
    /*#__PURE__*/
    _regenerator.default.mark(function save(_ref9, _ref10) {
      var payload, call, put, response, url, pageId, formData, param, rtnData;
      return _regenerator.default.wrap(function save$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              payload = _ref9.payload;
              call = _ref10.call, put = _ref10.put;
              response = payload.response;
              url = payload.url;
              pageId = payload.pageId;
              formData = payload.params.data;
              param = {
                url: url,
                params: formData instanceof Array ? formData : _objectSpread({}, formData)
              };
              _context5.next = 9;
              return call(_service.post, param, put);

            case 9:
              rtnData = _context5.sent;

              if (!(rtnData != null && rtnData[0] != null && rtnData[0]['f_id'] != null)) {
                _context5.next = 18;
                break;
              }

              _context5.next = 13;
              return put({
                type: 'saveSuccess',
                payload: {
                  pageId: pageId,
                  f_id: rtnData[0]['f_id']
                }
              });

            case 13:
              _context5.next = 15;
              return put({
                type: 'get',
                payload: {
                  pageId: pageId,
                  url: url.replace('.save', '.get'),
                  response: response,
                  params: {
                    f_id: rtnData[0]['f_id']
                  }
                }
              });

            case 15:
              return _context5.abrupt("return", rtnData[0]['f_id']);

            case 18:
              if (rtnData['msg'] != null) {
                _toast.default.fail(rtnData['msg'], 2);
              }

            case 19:
            case "end":
              return _context5.stop();
          }
        }
      }, save, this);
    }),
    get:
    /*#__PURE__*/
    _regenerator.default.mark(function get(_ref11, _ref12) {
      var payload, call, put, response, url, pageId, param, rtnData;
      return _regenerator.default.wrap(function get$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              payload = _ref11.payload;
              call = _ref12.call, put = _ref12.put;
              response = payload.response;
              url = payload.url;
              pageId = payload.pageId;
              param = {
                url: url,
                params: _objectSpread({}, payload.params)
              };
              _context6.next = 8;
              return call(_service.post, param, put);

            case 8:
              rtnData = _context6.sent;

              if (!(rtnData != null && rtnData[response] != null)) {
                _context6.next = 13;
                break;
              }

              _context6.next = 12;
              return put({
                type: 'getSuccess',
                payload: {
                  pageId: pageId,
                  data: rtnData[response],
                  put: put
                }
              });

            case 12:
              return _context6.abrupt("return", rtnData[response]);

            case 13:
            case "end":
              return _context6.stop();
          }
        }
      }, get, this);
    }),
    del:
    /*#__PURE__*/
    _regenerator.default.mark(function del(_ref13, _ref14) {
      var payload, call, put, response, url, pageId, formData, param, rtnData, state, parentPageId;
      return _regenerator.default.wrap(function del$(_context7) {
        while (1) {
          switch (_context7.prev = _context7.next) {
            case 0:
              payload = _ref13.payload;
              call = _ref14.call, put = _ref14.put;
              response = payload.response;
              url = payload.url;
              pageId = payload.pageId;
              formData = payload.params.data;
              formData.flag = 'D';
              param = {
                url: url,
                params: formData instanceof Array ? formData : _objectSpread({}, formData)
              };
              _context7.next = 10;
              return call(_service.post, param, put);

            case 10:
              rtnData = _context7.sent;

              if (!(rtnData != null && rtnData[0] != null && rtnData[0]['f_id'] != null)) {
                _context7.next = 24;
                break;
              }

              _context7.next = 14;
              return put({
                type: 'delSuccess',
                payload: {
                  pageId: pageId,
                  f_id: rtnData[0]['f_id']
                }
              });

            case 14:
              _context7.next = 16;
              return (0, _effects.select)();

            case 16:
              state = _context7.sent;
              parentPageId = state.page[pageId].parentPageId;

              if (!(parentPageId != null && parentPageId != '')) {
                _context7.next = 21;
                break;
              }

              _context7.next = 21;
              return put({
                type: 'stateChange',
                payload: {
                  pageId: parentPageId,
                  params: {
                    innerPageVisible: false,
                    innerPageId: '',
                    formId: ''
                  }
                }
              });

            case 21:
              return _context7.abrupt("return", rtnData[0]['f_id']);

            case 24:
              if (rtnData['msg'] != null) {
                _toast.default.fail(rtnData['msg'], 2);
              }

            case 25:
            case "end":
              return _context7.stop();
          }
        }
      }, del, this);
    }),
    openInnerPage:
    /*#__PURE__*/
    _regenerator.default.mark(function openInnerPage(_ref15, _ref16) {
      var payload, put, pageId, formId, innerPageId;
      return _regenerator.default.wrap(function openInnerPage$(_context8) {
        while (1) {
          switch (_context8.prev = _context8.next) {
            case 0:
              payload = _ref15.payload;
              put = _ref16.put;
              pageId = payload.pageId, formId = payload.formId, innerPageId = payload.innerPageId;
              _context8.next = 5;
              return put({
                type: 'stateChange',
                payload: {
                  pageId: pageId,
                  params: {
                    formId: formId,
                    innerPageId: innerPageId,
                    innerPageVisible: true
                  }
                }
              });

            case 5:
            case "end":
              return _context8.stop();
          }
        }
      }, openInnerPage, this);
    }),
    closeInnerPage:
    /*#__PURE__*/
    _regenerator.default.mark(function closeInnerPage(_ref17, _ref18) {
      var payload, put, pageId;
      return _regenerator.default.wrap(function closeInnerPage$(_context9) {
        while (1) {
          switch (_context9.prev = _context9.next) {
            case 0:
              payload = _ref17.payload;
              put = _ref18.put;
              pageId = payload.pageId;
              _context9.next = 5;
              return put({
                type: 'stateChange',
                payload: {
                  pageId: pageId,
                  params: {
                    formId: '',
                    innerPageId: '',
                    innerPageVisible: false
                  }
                }
              });

            case 5:
            case "end":
              return _context9.stop();
          }
        }
      }, closeInnerPage, this);
    }),
    post:
    /*#__PURE__*/
    _regenerator.default.mark(function post(_ref19, _ref20) {
      var payload, call, put, rtnData;
      return _regenerator.default.wrap(function post$(_context10) {
        while (1) {
          switch (_context10.prev = _context10.next) {
            case 0:
              payload = _ref19.payload;
              call = _ref20.call, put = _ref20.put;
              _context10.next = 4;
              return call(_service.post, payload, put);

            case 4:
              rtnData = _context10.sent;
              return _context10.abrupt("return", rtnData);

            case 6:
            case "end":
              return _context10.stop();
          }
        }
      }, post, this);
    }),
    searchUploadFileList:
    /*#__PURE__*/
    _regenerator.default.mark(function searchUploadFileList(_ref21, _ref22) {
      var payload, call, put, url, pageId, id, param, rtnData;
      return _regenerator.default.wrap(function searchUploadFileList$(_context11) {
        while (1) {
          switch (_context11.prev = _context11.next) {
            case 0:
              payload = _ref21.payload;
              call = _ref22.call, put = _ref22.put;
              url = payload.url, pageId = payload.pageId, id = payload.id;
              param = {
                url: url,
                params: {
                  billno: id
                }
              };
              _context11.next = 6;
              return call(_service.post, param, put);

            case 6:
              rtnData = _context11.sent;

              if (!(rtnData != null)) {
                _context11.next = 10;
                break;
              }

              _context11.next = 10;
              return put({
                type: 'stateChange',
                payload: {
                  pageId: pageId,
                  params: {
                    uploadFileList: rtnData
                  }
                }
              });

            case 10:
            case "end":
              return _context11.stop();
          }
        }
      }, searchUploadFileList, this);
    }),
    deleteUploadFile:
    /*#__PURE__*/
    _regenerator.default.mark(function deleteUploadFile(_ref23, _ref24) {
      var payload, call, put, url, searchUrl, id, pageId, fileId, param, rtnData;
      return _regenerator.default.wrap(function deleteUploadFile$(_context12) {
        while (1) {
          switch (_context12.prev = _context12.next) {
            case 0:
              payload = _ref23.payload;
              call = _ref24.call, put = _ref24.put;
              url = payload.url, searchUrl = payload.searchUrl, id = payload.id, pageId = payload.pageId, fileId = payload.fileId;
              param = {
                url: url,
                params: {
                  fileID: fileId
                }
              };
              _context12.next = 6;
              return call(_service.post, param, put);

            case 6:
              rtnData = _context12.sent;

              if (!(rtnData != null && rtnData.success)) {
                _context12.next = 11;
                break;
              }

              _toast.default.success('删除成功', 2);

              _context12.next = 11;
              return put({
                type: 'searchUploadFileList',
                payload: {
                  url: searchUrl,
                  pageId: pageId,
                  id: id
                }
              });

            case 11:
            case "end":
              return _context12.stop();
          }
        }
      }, deleteUploadFile, this);
    }),
    addDetail:
    /*#__PURE__*/
    _regenerator.default.mark(function addDetail(_ref25, _ref26) {
      var payload, put, pageId, params, state, pageState, detailKey, detailData, formData;
      return _regenerator.default.wrap(function addDetail$(_context13) {
        while (1) {
          switch (_context13.prev = _context13.next) {
            case 0:
              payload = _ref25.payload;
              put = _ref26.put;
              pageId = payload.pageId, params = payload.params;
              _context13.next = 5;
              return (0, _effects.select)();

            case 5:
              state = _context13.sent;
              pageState = state.page[pageId];
              detailKey = params.detailKey, detailData = params.detailData;
              formData = pageState.formData;

              if (formData[detailKey] == null) {
                formData[detailKey] = [];
              }

              formData[detailKey].push(detailData);
              _context13.next = 13;
              return put({
                type: 'stateChange',
                payload: {
                  pageId: pageId,
                  params: {
                    formData: formData,
                    detailFormKey: detailKey,
                    detailFormVisible: true,
                    detailFormData: detailData
                  }
                }
              });

            case 13:
              return _context13.abrupt("return", formData);

            case 14:
            case "end":
              return _context13.stop();
          }
        }
      }, addDetail, this);
    }),
    delDetail:
    /*#__PURE__*/
    _regenerator.default.mark(function delDetail(_ref27, _ref28) {
      var payload, put, pageId, params, state, pageState, rowKey, detailKey, dataId, formData, detailData, detailIndex, rowData;
      return _regenerator.default.wrap(function delDetail$(_context14) {
        while (1) {
          switch (_context14.prev = _context14.next) {
            case 0:
              payload = _ref27.payload;
              put = _ref28.put;
              pageId = payload.pageId, params = payload.params;
              _context14.next = 5;
              return (0, _effects.select)();

            case 5:
              state = _context14.sent;
              pageState = state.page[pageId];
              rowKey = params.rowKey, detailKey = params.detailKey, dataId = params.dataId;
              formData = pageState.formData;
              detailData = formData[detailKey];

              if (dataId != null && dataId != '') {
                detailIndex = -1;
                rowData = detailData.find(function (value, index) {
                  detailIndex = index;
                  return value[rowKey] == dataId;
                });

                if (rowData.flag == 'I') {
                  detailData.splice(detailIndex, 1);
                } else {
                  rowData['flag'] = 'D';
                }
              }

              _context14.next = 13;
              return put({
                type: 'stateChange',
                payload: {
                  pageId: pageId,
                  params: {
                    formData: formData,
                    detailFormVisible: false,
                    detailFormData: {}
                  }
                }
              });

            case 13:
              return _context14.abrupt("return", formData);

            case 14:
            case "end":
              return _context14.stop();
          }
        }
      }, delDetail, this);
    })
  },
  reducers: {
    stateChange: function stateChange(state, action) {
      var newState = JSON.parse(JSON.stringify(state));
      var pageId = action.payload.pageId;

      for (var key in action.payload.params) {
        if (newState[pageId] != null) {
          newState[pageId][key] = action.payload.params[key];
        }
      }

      return _objectSpread({}, newState);
    },
    clearPageState: function clearPageState(state, action) {
      var pageId = action.payload.pageId;
      delete state[pageId];
      return _objectSpread({}, state);
    },
    searchSuccess: function searchSuccess(state, action) {
      var _action$payload = action.payload,
          pageId = _action$payload.pageId,
          data = _action$payload.data,
          totalCount = _action$payload.totalCount;
      state[pageId].tableData = state[pageId].tableData.concat(data);
      state[pageId].totalCount = totalCount;
      return _objectSpread({}, state);
    },
    searchTreeDataSuccess: function searchTreeDataSuccess(state, action) {
      var _action$payload2 = action.payload,
          pageId = _action$payload2.pageId,
          data = _action$payload2.data;
      state[pageId].treeData = data;
      return _objectSpread({}, state);
    },
    loadDesignSuccess: function loadDesignSuccess(state, action) {
      var pageId = action.payload.pageId;

      if (state[pageId] == null || state[pageId].searchParams == null) {
        state[pageId] = _objectSpread({}, action.payload, {
          searchParams: {
            page_no: 1,
            page_size: 10,
            1: 1
          },
          queryViewVisible: false,
          formData: {},
          tableData: [],
          operationLogs: [],
          uploadFileList: [],
          parentPageId: '',
          formId: '',
          operationType: 'V',
          detailFormVisible: false,
          detailFormData: {}
        });
      } else {
        state[pageId] = _objectSpread({}, state[pageId], action.payload);
      }

      return _objectSpread({}, state);
    },
    loadDictSuccess: function loadDictSuccess(state, action) {
      return _objectSpread({}, state, {
        dict: action.payload.data
      });
    },
    setFormValues: function setFormValues(state, action) {
      var pageId = action.payload.pageId;
      var newState = state;
      var formData = newState[pageId].formData;

      for (var key in action.payload.values) {
        var value = action.payload.values[key];
        formData[key] = value;
      }

      return _objectSpread({}, newState);
    },
    saveSuccess: function saveSuccess(state, action) {
      var pageId = action.payload.pageId;
      var newState = JSON.parse(JSON.stringify(state));
      newState[pageId].operationType = 'V';
      newState[pageId].formData = _objectSpread({}, newState.formData, {
        flag: 'U',
        f_id: action.payload.f_id
      });

      _toast.default.success('保存成功', 2);

      return _objectSpread({}, newState);
    },
    delSuccess: function delSuccess(state, action) {
      var pageId = action.payload.pageId;
      var newState = JSON.parse(JSON.stringify(state));
      newState[pageId].operationType = 'V';
      newState[pageId].formData = {};

      _toast.default.success('删除成功', 2);

      return _objectSpread({}, newState);
    },
    getSuccess: function getSuccess(state, action) {
      var newState = JSON.parse(JSON.stringify(state));
      var pageId = action.payload.pageId;
      newState[pageId].formData = _objectSpread({}, action.payload.data, {
        flag: 'U'
      });
      return _objectSpread({}, newState);
    }
  }
};
var _default = page;
exports.default = _default;