"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = loginSuccess;

/* global sessionStorage */
function loginSuccess(appCode, menuAuthList, btnAuthList, token, user) {
  var menus = [];

  for (var _i = 0; _i < menuAuthList.length; _i += 1) {
    var menuAuth = menuAuthList[_i];

    if (menuAuth.f_appcode != appCode) {
      continue;
    }

    if (menuAuth['f_enabledmark'] == '1') {
      var menu = {};

      if (menuAuth['f_icon'] != null) {
        menu = {
          fid: menuAuth['f_id'],
          key: menuAuth['f_permcode'],
          title: menuAuth['f_name'],
          url: menuAuth['f_url'],
          icon: menuAuth['f_icon'],
          parentId: menuAuth['f_parentid'],
          toolbarBtnKeys: ''
        };

        for (var _j = 0; _j < btnAuthList.length; _j += 1) {
          var btnAuth = btnAuthList[_j];

          if (btnAuth.f_appcode != appCode) {
            continue;
          }

          if (menuAuth['f_id'] == btnAuth['f_parentid']) {
            menu['toolbarBtnKeys'] += btnAuth['f_permcode'] + ',';
          }
        }

        menus.push(menu);
      }
    }
  }

  var r = [];
  var hash = {};
  var id = 'fid';
  var pid = 'parentId';
  var children = 'children';
  var i = 0;
  var j = 0;
  var len = menus.length;

  for (; i < len; i += 1) {
    hash[menus[i][id]] = menus[i];
  }

  for (; j < len; j += 1) {
    var aVal = menus[j];
    var hashVP = hash[aVal[pid]];

    if (hashVP) {
      if (!hashVP[children]) {
        hashVP[children] = [];
      }

      hashVP[children].push(aVal);
    } else {
      r.push(aVal);
    }
  }

  sessionStorage.setItem('title', '首页');
  sessionStorage.setItem('menus', JSON.stringify(r));
  sessionStorage.setItem('token', token);
  sessionStorage.setItem('loginUser', JSON.stringify(user));
  sessionStorage.setItem('activeKey', '');
  sessionStorage.setItem('collapsed', 'true');
  sessionStorage.setItem('openKeys', '[]');
}