"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es6.object.keys");

require("core-js/modules/es6.array.find");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("antd-mobile/es/toast/style");

var _toast = _interopRequireDefault(require("antd-mobile/es/toast"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

require("regenerator-runtime/runtime");

var _qs = require("qs");

var _effects = require("redux-saga/effects");

var _service = require("./service");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var _default = {
  state: {
    operationType: 'V',
    selectedRows: [],
    tableFields: [],
    tableData: [],
    formData: {},
    toolbarRule: null,
    selectedKeys: [],
    detailSelectedKeys: [],
    editEnable: false,
    searchParams: {},
    pageNo: 1,
    pageSize: 10,
    processVisible: false,
    detailVisible: false,
    addVisible: false
  },
  effects: {
    search:
    /*#__PURE__*/
    _regenerator.default.mark(function search(_ref, _ref2) {
      var payload, call, put, response, url, modelName, state, searchParams, param, rtnData;
      return _regenerator.default.wrap(function search$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              payload = _ref.payload;
              call = _ref2.call, put = _ref2.put;
              response = payload.response;
              url = payload.url;
              modelName = payload.modelName;
              _context.next = 7;
              return (0, _effects.select)();

            case 7:
              state = _context.sent;
              searchParams = state[modelName].searchParams;

              if (searchParams == null) {
                searchParams = {};
              }

              param = {
                url: url,
                params: _objectSpread({
                  order_field: 'f_createdate',
                  order_direction: 'desc'
                }, searchParams, payload.params)
              };
              _context.next = 13;
              return call(_service.post, (0, _qs.parse)(param), put);

            case 13:
              rtnData = _context.sent;

              if (!(rtnData != null && rtnData[response] != null)) {
                _context.next = 17;
                break;
              }

              _context.next = 17;
              return put({
                type: 'searchSuccess',
                payload: {
                  data: rtnData[response],
                  totalCount: rtnData.total_results
                }
              });

            case 17:
            case "end":
              return _context.stop();
          }
        }
      }, search, this);
    }),
    get:
    /*#__PURE__*/
    _regenerator.default.mark(function get(_ref3, _ref4) {
      var payload, call, put, url, response, formKey, param, rtnData;
      return _regenerator.default.wrap(function get$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              payload = _ref3.payload;
              call = _ref4.call, put = _ref4.put;
              url = payload.url;
              response = payload.response;
              formKey = payload.formKey == null ? 'formData' : payload.formKey;
              param = {
                url: url,
                params: _objectSpread({}, payload.params)
              };
              _context2.next = 8;
              return call(_service.post, (0, _qs.parse)(param), put);

            case 8:
              rtnData = _context2.sent;

              if (!(rtnData != null && rtnData[response] != null)) {
                _context2.next = 13;
                break;
              }

              _context2.next = 12;
              return put({
                type: 'getSuccess',
                payload: {
                  formKey: formKey,
                  data: rtnData[response],
                  put: put
                }
              });

            case 12:
              return _context2.abrupt("return", rtnData[response]);

            case 13:
            case "end":
              return _context2.stop();
          }
        }
      }, get, this);
    }),
    goToDetail:
    /*#__PURE__*/
    _regenerator.default.mark(function goToDetail(_ref5, _ref6) {
      var payload, call, put;
      return _regenerator.default.wrap(function goToDetail$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              payload = _ref5.payload;
              call = _ref6.call, put = _ref6.put;

            case 2:
            case "end":
              return _context3.stop();
          }
        }
      }, goToDetail, this);
    }),
    save:
    /*#__PURE__*/
    _regenerator.default.mark(function save(_ref7, _ref8) {
      var payload, call, put, modelName, url, formData, param, rtnData, state;
      return _regenerator.default.wrap(function save$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              payload = _ref7.payload;
              call = _ref8.call, put = _ref8.put;
              modelName = payload.modelName;
              url = payload.url;
              formData = payload.params.data;
              param = {
                url: url,
                params: formData instanceof Array ? formData : _objectSpread({}, formData)
              };
              _context4.next = 8;
              return call(_service.post, (0, _qs.parse)(param), put);

            case 8:
              rtnData = _context4.sent;

              if (!(rtnData != null && rtnData[0] != null && rtnData[0]['f_id'] != null)) {
                _context4.next = 21;
                break;
              }

              _context4.next = 12;
              return put({
                type: 'saveSuccess',
                payload: {
                  f_id: rtnData[0]['f_id']
                }
              });

            case 12:
              _context4.next = 14;
              return (0, _effects.select)();

            case 14:
              state = _context4.sent;
              _context4.next = 17;
              return put({
                type: 'get',
                payload: {
                  url: state[modelName].getUrl,
                  response: state[modelName].response,
                  modelName: modelName,
                  params: {
                    f_id: rtnData[0]['f_id']
                  }
                }
              });

            case 17:
              _context4.next = 19;
              return put({
                type: 'search',
                payload: {
                  url: state[modelName].searchUrl,
                  response: state[modelName].response,
                  modelName: modelName
                }
              });

            case 19:
              _context4.next = 22;
              break;

            case 21:
              if (rtnData['msg'] != null) {
                _toast.default.fail(rtnData['msg'], 2);
              }

            case 22:
            case "end":
              return _context4.stop();
          }
        }
      }, save, this);
    }),
    submit:
    /*#__PURE__*/
    _regenerator.default.mark(function submit(_ref9, _ref10) {
      var payload, call, put, modelName, url, formData, param, rtnData, state;
      return _regenerator.default.wrap(function submit$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              payload = _ref9.payload;
              call = _ref10.call, put = _ref10.put;
              modelName = payload.modelName;
              url = payload.url;
              formData = payload.params.data;
              param = {
                url: url,
                params: formData instanceof Array ? formData : _objectSpread({}, formData)
              };
              _context5.next = 8;
              return call(_service.post, (0, _qs.parse)(param), put);

            case 8:
              rtnData = _context5.sent;

              if (!(rtnData != null && rtnData[0] != null && rtnData[0]['f_id'] != null)) {
                _context5.next = 21;
                break;
              }

              _context5.next = 12;
              return put({
                type: 'submitSuccess',
                payload: {
                  f_id: rtnData[0]['f_id']
                }
              });

            case 12:
              _context5.next = 14;
              return (0, _effects.select)();

            case 14:
              state = _context5.sent;
              _context5.next = 17;
              return put({
                type: 'get',
                payload: {
                  url: state[modelName].getUrl,
                  response: state[modelName].response,
                  params: {
                    f_id: rtnData[0]['f_id']
                  }
                }
              });

            case 17:
              _context5.next = 19;
              return put({
                type: 'search',
                payload: {
                  url: state[modelName].searchUrl,
                  response: state[modelName].response,
                  modelName: modelName
                }
              });

            case 19:
              _context5.next = 22;
              break;

            case 21:
              if (rtnData['msg'] != null) {
                _toast.default.fail(rtnData['msg'], 2);
              }

            case 22:
            case "end":
              return _context5.stop();
          }
        }
      }, submit, this);
    }),
    del:
    /*#__PURE__*/
    _regenerator.default.mark(function del(_ref11, _ref12) {
      var payload, call, put, modelName, url, formData, param, rtnData, state;
      return _regenerator.default.wrap(function del$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              payload = _ref11.payload;
              call = _ref12.call, put = _ref12.put;
              modelName = payload.modelName;
              url = payload.url;
              formData = payload.params.data;
              formData['flag'] = 'D';
              param = {
                url: url,
                params: _objectSpread({}, formData)
              };
              _context6.next = 9;
              return call(_service.post, (0, _qs.parse)(param), put);

            case 9:
              rtnData = _context6.sent;

              if (!(rtnData != null && rtnData[0] != null && rtnData[0]['f_id'] != null)) {
                _context6.next = 18;
                break;
              }

              _context6.next = 13;
              return put({
                type: 'delSuccess'
              });

            case 13:
              _context6.next = 15;
              return (0, _effects.select)();

            case 15:
              state = _context6.sent;
              _context6.next = 18;
              return put({
                type: 'search',
                payload: {
                  url: state[modelName].searchUrl,
                  response: state[modelName].response,
                  modelName: modelName
                }
              });

            case 18:
            case "end":
              return _context6.stop();
          }
        }
      }, del, this);
    }),
    searchFields:
    /*#__PURE__*/
    _regenerator.default.mark(function searchFields(_ref13, _ref14) {
      var payload, call, put, response, url, param, rtnData;
      return _regenerator.default.wrap(function searchFields$(_context7) {
        while (1) {
          switch (_context7.prev = _context7.next) {
            case 0:
              payload = _ref13.payload;
              call = _ref14.call, put = _ref14.put;
              response = payload.response;
              url = payload.url;
              param = {
                url: url,
                params: _objectSpread({}, payload.params)
              };
              _context7.next = 7;
              return call(_service.post, (0, _qs.parse)(param), put);

            case 7:
              rtnData = _context7.sent;

              if (!(rtnData != null && rtnData.length > 0)) {
                _context7.next = 11;
                break;
              }

              _context7.next = 11;
              return put({
                type: 'searchFieldsSuccess',
                payload: {
                  data: rtnData
                }
              });

            case 11:
            case "end":
              return _context7.stop();
          }
        }
      }, searchFields, this);
    })
  },
  reducers: {
    setForm: function setForm(state, action) {
      return _objectSpread({}, state, {
        form: action.payload.form
      });
    },
    stateChange: function stateChange(state, action) {
      return _objectSpread({}, state, action.payload);
    },
    setFormValue: function setFormValue(state, action) {
      var newState = _objectSpread({}, state);

      var formKey = '';

      if (action.payload.formKey == null) {
        formKey = 'formData';
      }

      newState[formKey] = _objectSpread({}, state[formKey], action.payload.values);
      return newState;
    },
    setDetailValue: function setDetailValue(state, action) {
      var formKey = '';

      if (action.payload.formKey == null) {
        formKey = 'formData';
      }

      var _action$payload = action.payload,
          id = _action$payload.id,
          detailKey = _action$payload.detailKey,
          values = _action$payload.values;
      var formData = JSON.parse(JSON.stringify(state[formKey]));

      for (var i = 0; i < formData[detailKey].length; i += 1) {
        if (formData[detailKey][i].f_id == id) {
          for (var key in values) {
            formData[detailKey][i][key] = values[key];
          }
        }
      }

      return _objectSpread({}, state, {
        formData: formData
      });
    },
    addDetail: function addDetail(state, action) {
      var newState = _objectSpread({}, state);

      var detailKey = action.payload.detailKey;
      var detailData = action.payload.detailData;
      var formKey = action.payload.formKey == null ? 'formData' : action.payload.formKey;
      var formData = state[formKey];

      if (formData[detailKey] == null) {
        formData[detailKey] = [];
      }

      formData[detailKey].push(detailData);
      newState[formKey] = formData;
      return newState;
    },
    delDetail: function delDetail(state, action) {
      var newState = _objectSpread({}, state);

      var formKey = action.payload.formKey == null ? 'formData' : action.payload.formKey;
      var formData = state[formKey];
      var _action$payload2 = action.payload,
          detailKey = _action$payload2.detailKey,
          rowKey = _action$payload2.rowKey;
      var detailData = formData[detailKey] == null ? [] : formData[detailKey];
      var detailSelectedKeys = state.detailSelectedKeys;

      if (detailSelectedKeys != null && detailSelectedKeys.length == 1) {
        var detailIndex = -1;
        var detail = detailData.find(function (value, index) {
          detailIndex = index;
          return value[rowKey] == detailSelectedKeys[0];
        });

        if (detail.flag == 'I') {
          detailData.splice(detailIndex, 1);
        } else {
          detail['flag'] = 'D';
        }
      }

      newState[formKey] = formData;
      return newState;
    },
    initFormData: function initFormData(state, action) {
      if (state.form != null) {
        state.form.resetFields();
      }

      var formData = {
        // status: 'A',
        flag: 'I'
      };

      if (action.payload && action.payload.formData) {
        formData = _objectSpread({}, formData, action.payload.formData);
      }

      return _objectSpread({}, state, action.payload, {
        formData: formData
      });
    },
    saveSuccess: function saveSuccess(state, action) {
      message.success('保存成功', 2);
      return _objectSpread({}, state, {
        operationType: 'V',
        editEnable: false,
        formData: _objectSpread({}, state.formData, {
          flag: 'U',
          f_id: action.payload.f_id
        })
      });
    },
    submitSuccess: function submitSuccess(state, action) {
      message.success('提交成功', 2);
      return _objectSpread({}, state, {
        operationType: 'V',
        editEnable: false,
        formData: _objectSpread({}, state.formData, {
          flag: 'U',
          f_id: action.payload.f_id
        })
      });
    },
    getSuccess: function getSuccess(state, action) {
      var newState = _objectSpread({}, state, {
        tabsActiveKey: '2',
        operationType: 'V',
        editEnable: false
      });

      var formData = _objectSpread({}, action.payload.data, {
        flag: 'U'
      }); // for (const key in formData) {
      //   if (!Object.prototype.hasOwnProperty.call(formData, key)) {
      //     continue;
      //   }
      //   if (formData[key] instanceof Array) {
      //     const details = formData[key];
      //     for (let i = 0; i < details.length; i += 1) {
      //       details[i]['flag'] = 'U';
      //     }
      //   }
      // }


      newState[action.payload.formKey] = formData;
      return newState;
    },
    searchSuccess: function searchSuccess(state, action) {
      var _action$payload3 = action.payload,
          data = _action$payload3.data,
          totalCount = _action$payload3.totalCount;
      return _objectSpread({}, state, {
        tableData: data,
        totalCount: totalCount
      });
    },
    changeToolbarStatus: function changeToolbarStatus(state) {
      return _objectSpread({}, state);
    },
    delSuccess: function delSuccess(state) {
      message.success('删除成功', 2);
      var pageSize = state.pageSize,
          totalCount = state.totalCount,
          searchParams = state.searchParams;
      var pageNo = state.pageNo;

      if (pageNo > (totalCount - 1) / pageSize) {
        pageNo = parseInt(totalCount / pageSize, 10);
      }

      searchParams.page_no = pageNo;
      return _objectSpread({}, state, {
        pageNo: pageNo,
        searchParams: searchParams,
        operationType: 'V',
        editEnable: false,
        formData: _objectSpread({}, state.formData, {
          status: 'A',
          flag: 'I'
        }),
        addVisible: false,
        detailVisible: false
      });
    },
    selectDetail: function selectDetail(state, action) {
      var key = action.payload.key;
      return _objectSpread({}, state, {
        detailSelectedKeys: key
      });
    },
    searchFieldsSuccess: function searchFieldsSuccess(state, action) {
      return _objectSpread({}, state, {
        tableFields: action.payload.data
      });
    }
  }
};
exports.default = _default;