"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = request;

require("antd-mobile/es/toast/style");

var _toast = _interopRequireDefault(require("antd-mobile/es/toast"));

var _fetch = _interopRequireDefault(require("dva/fetch"));

var _dataHandle = _interopRequireDefault(require("./dataHandle"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function parseJSON(response) {
  return response.json();
}

function parseText(response) {
  return response.text();
}

function checkStatus(response) {
  if (response.status >= 200 && response.status < 300) {
    return response;
  }

  if (response.status == 500) {
    _toast.default.fail('服务异常');
  }

  var error = new Error(response.statusText);
  error.response = response;
  throw error;
}
/**
 * Requests a URL, returning a promise.
 *
 * @param  {string} url       The URL we want to request
 * @param  {object} [options] The options we want to pass to "fetch"
 * @return {object}           An object containing either "data" or "err"
 */


function request(url, options) {
  options['headers']['Content-Type'] = 'application/json;charset=utf-8';
  return (0, _fetch.default)(url, options).then(checkStatus).then(parseJSON).then(function (data) {
    return (0, _dataHandle.default)({
      data: data
    });
  }).catch(function (err) {
    return {
      err: err
    };
  });
}